/*----- PROTECTED REGION ID(SimulatedE2BPM.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        SimulatedE2BPM.cpp
//
// description : C++ source for the SimulatedE2BPM class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               SimulatedE2BPM are implemented in this file.
//
// project :     SimulatedE2BPM
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include "SimulatedE2BPM.h"
#include "SimulatedE2BPMClass.h"
#include <iterator>
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM.cpp

/**
 *  SimulatedE2BPM class description:
 *    Class implementing a simulated Elettra 2.0 BPM postion momitor
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//  Reset         |  reset
//  GetBPMName    |  get_bpmname
//  GetBPMIndex   |  get_bpmindex
//  Fault         |  fault
//  On            |  on
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  HorOffset         |  Tango::DevDouble	Scalar
//  HorPos            |  Tango::DevDouble	Scalar
//  Sum               |  Tango::DevDouble	Scalar
//  BufSize           |  Tango::DevULong64	Scalar
//  tbtEnable         |  Tango::DevBoolean	Scalar
//  VerOffset         |  Tango::DevDouble	Scalar
//  VerPos            |  Tango::DevDouble	Scalar
//  rawHorPos         |  Tango::DevDouble	Scalar
//  rawVerPos         |  Tango::DevDouble	Scalar
//  injectCurr        |  Tango::DevDouble	Scalar
//  ScaleFactor       |  Tango::DevDouble	Scalar
//  HorPosHistory     |  Tango::DevDouble	Spectrum  ( max = 10000)
//  VerPosHistory     |  Tango::DevDouble	Spectrum  ( max = 10000)
//  SumHistory        |  Tango::DevDouble	Spectrum  ( max = 10000)
//  rawHorPosHistory  |  Tango::DevDouble	Spectrum  ( max = 10000)
//  rawVerPosHistory  |  Tango::DevDouble	Spectrum  ( max = 10000)
//================================================================

namespace SimulatedE2BPM_ns
{
/*----- PROTECTED REGION ID(SimulatedE2BPM::namespace_starting) ENABLED START -----*/
/* clang-format on */
//	static initializations
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::namespace_starting

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::SimulatedE2BPM()
 *	Description: Constructors for a Tango device
 *                implementing the classSimulatedE2BPM
 */
//--------------------------------------------------------
SimulatedE2BPM::SimulatedE2BPM(Tango::DeviceClass *cl, std::string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(SimulatedE2BPM::constructor_1) ENABLED START -----*/
	/* clang-format on */
	init_device();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::constructor_1
}
//--------------------------------------------------------
SimulatedE2BPM::SimulatedE2BPM(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(SimulatedE2BPM::constructor_2) ENABLED START -----*/
	/* clang-format on */
	init_device();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::constructor_2
}
//--------------------------------------------------------
SimulatedE2BPM::SimulatedE2BPM(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(SimulatedE2BPM::constructor_3) ENABLED START -----*/
	/* clang-format on */
	init_device();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::constructor_3
}
//--------------------------------------------------------
SimulatedE2BPM::~SimulatedE2BPM()
{
	delete_device();
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::delete_device()
 *	Description: will be called at device destruction or at init command
 */
//--------------------------------------------------------
void SimulatedE2BPM::delete_device()
{
	DEBUG_STREAM << "SimulatedE2BPM::delete_device() " << device_name << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::delete_device) ENABLED START -----*/
	/* clang-format on */
	//	Delete device allocated objects
	if(orbit_dev){
		delete orbit_dev;
		orbit_dev = nullptr;
	}
	n_turns = 1; //
	n_turns_new_value();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::delete_device
	delete[] attr_HorOffset_read;
	delete[] attr_HorPos_read;
	delete[] attr_Sum_read;
	delete[] attr_BufSize_read;
	delete[] attr_tbtEnable_read;
	delete[] attr_VerOffset_read;
	delete[] attr_VerPos_read;
	delete[] attr_rawHorPos_read;
	delete[] attr_rawVerPos_read;
	delete[] attr_ScaleFactor_read;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::init_device()
 *	Description: will be called at device initialization.
 */
//--------------------------------------------------------
void SimulatedE2BPM::init_device()
{
	DEBUG_STREAM << "SimulatedE2BPM::init_device() create device " << device_name << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::init_device_before) ENABLED START -----*/
	/* clang-format on */
	//	Initialization before get_device_property() call
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::init_device_before


	//	Get the device properties from database
	get_device_property();

	attr_HorOffset_read = new Tango::DevDouble[1];
	attr_HorPos_read = new Tango::DevDouble[1];
	attr_Sum_read = new Tango::DevDouble[1];
	attr_BufSize_read = new Tango::DevULong64[1];
	attr_tbtEnable_read = new Tango::DevBoolean[1];
	attr_VerOffset_read = new Tango::DevDouble[1];
	attr_VerPos_read = new Tango::DevDouble[1];
	attr_rawHorPos_read = new Tango::DevDouble[1];
	attr_rawVerPos_read = new Tango::DevDouble[1];
	attr_ScaleFactor_read = new Tango::DevDouble[1];
	//	No longer if mandatory property not set.
	if (mandatoryNotDefined)
		return;

	/*----- PROTECTED REGION ID(SimulatedE2BPM::init_device) ENABLED START -----*/
	/* clang-format on */
	//	Initialize device
	try
	    {
			orbit_dev = new Tango::DeviceProxy(orbitDevName);
	    }
	    catch (Tango::DevFailed &e)
	    {
	        stringstream ss;
	        ss << "Can't create connection to device " << orbitDevName;
	        ss << "\n" << e.errors[0].desc.in();
	        set_status(ss.str());
	        set_state(Tango::UNKNOWN);
			orbit_dev = nullptr;
	        return;
	    }

	*attr_rawHorPos_read = 0.0;
	*attr_rawVerPos_read = 0.0;
	*attr_ScaleFactor_read = 1.0;
	injected_curr = 0.0;
	*attr_HorOffset_read = memHorOffset;
	*attr_VerOffset_read = memVerOffset;

	*attr_HorPos_read = *attr_rawHorPos_read + *attr_HorOffset_read;
	*attr_VerPos_read = *attr_rawVerPos_read + *attr_VerOffset_read;
	*attr_BufSize_read = 1;
	*attr_tbtEnable_read = false;

	Tango::MultiAttribute *attr_list = get_device_attr();
	Tango::WAttribute *enab = &(attr_list->get_w_attr_by_name("tbtEnable"));
	enab->set_write_value(false);
	try{ // force write part of attributes
		Tango::WAttribute *busize = &(attr_list->get_w_attr_by_name("BufSize"));
		busize->set_write_value(*attr_BufSize_read);
	}
	catch(...){
		ERROR_STREAM <<"SimulatedE2BPM::init_device() failed to init tbtBufSize write value"; // ignore error!
	}
	set_state(Tango::ON);

	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::init_device
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::get_device_property()
 *	Description: Read database to initialize property data members.
 */
//--------------------------------------------------------
void SimulatedE2BPM::get_device_property()
{
	/*----- PROTECTED REGION ID(SimulatedE2BPM::get_device_property_before) ENABLED START -----*/
	/* clang-format on */
	//	Initialize property data members
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::get_device_property_before

	mandatoryNotDefined = false;

	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("MemHorOffset"));
	dev_prop.push_back(Tango::DbDatum("MemVerOffset"));
	dev_prop.push_back(Tango::DbDatum("Index"));
	dev_prop.push_back(Tango::DbDatum("Name"));
	dev_prop.push_back(Tango::DbDatum("CurrToSum"));
	dev_prop.push_back(Tango::DbDatum("OrbitDevName"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);

		//	get instance on SimulatedE2BPMClass to get class property
		Tango::DbDatum	def_prop, cl_prop;
		SimulatedE2BPMClass	*ds_class =
			(static_cast<SimulatedE2BPMClass *>(get_device_class()));
		int	i = -1;

		//	Try to initialize MemHorOffset from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  memHorOffset;
		else {
			//	Try to initialize MemHorOffset from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  memHorOffset;
		}
		//	And try to extract MemHorOffset value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  memHorOffset;

		//	Try to initialize MemVerOffset from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  memVerOffset;
		else {
			//	Try to initialize MemVerOffset from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  memVerOffset;
		}
		//	And try to extract MemVerOffset value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  memVerOffset;

		//	Try to initialize Index from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  index;
		else {
			//	Try to initialize Index from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  index;
		}
		//	And try to extract Index value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  index;

		//	Try to initialize Name from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  name;
		else {
			//	Try to initialize Name from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  name;
		}
		//	And try to extract Name value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  name;

		//	Try to initialize CurrToSum from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  currToSum;
		else {
			//	Try to initialize CurrToSum from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  currToSum;
		}
		//	And try to extract CurrToSum value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  currToSum;

		//	Try to initialize OrbitDevName from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  orbitDevName;
		else {
			//	Try to initialize OrbitDevName from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  orbitDevName;
		}
		//	And try to extract OrbitDevName value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  orbitDevName;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

	}

	/*----- PROTECTED REGION ID(SimulatedE2BPM::get_device_property_after) ENABLED START -----*/
	/* clang-format on */
	//	Check device property data members init
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::get_device_property_after
}
//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::check_mandatory_property()
 *	Description: For mandatory properties check if defined in database.
 */
//--------------------------------------------------------
void SimulatedE2BPM::check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop)
{
	//	Check if all properties are empty
	if (class_prop.is_empty() && dev_prop.is_empty())
	{
		TangoSys_OMemStream	tms;
		tms << std::endl <<"Property \'" << dev_prop.name;
		if (Tango::Util::instance()->_UseDb==true)
			tms << "\' is mandatory but not defined in database";
		else
			tms << "\' is mandatory but cannot be defined without database";
		append_status(tms.str());
		mandatoryNotDefined = true;
		/*----- PROTECTED REGION ID(SimulatedE2BPM::check_mandatory_property) ENABLED START -----*/
		/* clang-format on */
		std::cerr << tms.str() << " for " << device_name << std::endl;
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::check_mandatory_property
	}
}


//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::always_executed_hook()
 *	Description: method always executed before any command is executed
 */
//--------------------------------------------------------
void SimulatedE2BPM::always_executed_hook()
{
	DEBUG_STREAM << "SimulatedE2BPM::always_executed_hook()  " << device_name << std::endl;
	if (mandatoryNotDefined)
	{
		Tango::Except::throw_exception(
					(const char *)"PROPERTY_NOT_SET",
					get_status().c_str(),
					(const char *)"SimulatedE2BPM::always_executed_hook()");
	}
	/*----- PROTECTED REGION ID(SimulatedE2BPM::always_executed_hook) ENABLED START -----*/
	/* clang-format on */
	//	code always executed before all requests
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::read_attr_hardware()
 *	Description: Hardware acquisition for attributes
 */
//--------------------------------------------------------
void SimulatedE2BPM::read_attr_hardware(TANGO_UNUSED(std::vector<long> &attr_list))
{
	DEBUG_STREAM << "SimulatedE2BPM::read_attr_hardware(std::vector<long> &attr_list) entering... " << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::read_attr_hardware) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::write_attr_hardware()
 *	Description: Hardware writing for attributes
 */
//--------------------------------------------------------
void SimulatedE2BPM::write_attr_hardware(TANGO_UNUSED(std::vector<long> &attr_list))
{
	DEBUG_STREAM << "SimulatedE2BPM::write_attr_hardware(std::vector<long> &attr_list) entering... " << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::write_attr_hardware) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute HorOffset related method
 *	Description: horizontal BPM offset - default 0
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SimulatedE2BPM::read_HorOffset(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::read_HorOffset(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::read_HorOffset) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr.set_value(attr_HorOffset_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::read_HorOffset
}
//--------------------------------------------------------
/**
 *	Write attribute HorOffset related method
 *	Description: horizontal BPM offset - default 0
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SimulatedE2BPM::write_HorOffset(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::write_HorOffset(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(SimulatedE2BPM::write_HorOffset) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	*attr_HorOffset_read = w_val;
	update_offset_scale();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::write_HorOffset
}
//--------------------------------------------------------
/**
 *	Read attribute HorPos related method
 *	Description: Horizontal position [mm] readout, including offsets and scale factors
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SimulatedE2BPM::read_HorPos(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::read_HorPos(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::read_HorPos) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	try{
			Tango::DeviceAttribute da = orbit_dev->read_attribute("HorPos");
			da >> h_pos;
			*attr_rawHorPos_read = h_pos[index] ;
			*attr_HorPos_read = (*attr_rawHorPos_read * *attr_ScaleFactor_read) +  *attr_HorOffset_read;
		}
		catch (Tango::DevFailed& e)
		{
			*attr_rawHorPos_read = NAN;
			*attr_HorPos_read = (*attr_rawHorPos_read * *attr_ScaleFactor_read) +  *attr_HorOffset_read;
			set_status("error reading HorPos");
			ERROR_STREAM << "error reading ClosedOrbit_h from : " << orbitDevName.c_str()<< std::endl;
			Tango::Except::re_throw_exception(e,(const char*) "Failed to read HorPos", (const char*) "DevFailed from simulator device", (const char*) "SimulatedBeamOrbit::read_HorPos");
		}
	attr.set_value(attr_HorPos_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::read_HorPos
}
//--------------------------------------------------------
/**
 *	Read attribute Sum related method
 *	Description: Sum signal proprtional to beam current
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SimulatedE2BPM::read_Sum(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::read_Sum(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::read_Sum) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr.set_value(attr_Sum_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::read_Sum
}
//--------------------------------------------------------
/**
 *	Read attribute BufSize related method
 *	Description: Turn by turn buffer size
 *
 *	Data type:	Tango::DevULong64
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SimulatedE2BPM::read_BufSize(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::read_BufSize(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::read_BufSize) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr.set_value(attr_BufSize_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::read_BufSize
}
//--------------------------------------------------------
/**
 *	Write attribute BufSize related method
 *	Description: Turn by turn buffer size
 *
 *	Data type:	Tango::DevULong64
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SimulatedE2BPM::write_BufSize(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::write_BufSize(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevULong64	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(SimulatedE2BPM::write_BufSize) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::write_BufSize
}
//--------------------------------------------------------
/**
 *	Read attribute tbtEnable related method
 *	Description: Enable the turn by turn mode
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SimulatedE2BPM::read_tbtEnable(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::read_tbtEnable(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::read_tbtEnable) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr.set_value(attr_tbtEnable_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::read_tbtEnable
}
//--------------------------------------------------------
/**
 *	Write attribute tbtEnable related method
 *	Description: Enable the turn by turn mode
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SimulatedE2BPM::write_tbtEnable(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::write_tbtEnable(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(SimulatedE2BPM::write_tbtEnable) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	*attr_tbtEnable_read = w_val;  // code not yet functional!
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::write_tbtEnable
}
//--------------------------------------------------------
/**
 *	Read attribute VerOffset related method
 *	Description: vertical BPM offset - default 0
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SimulatedE2BPM::read_VerOffset(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::read_VerOffset(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::read_VerOffset) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr.set_value(attr_VerOffset_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::read_VerOffset
}
//--------------------------------------------------------
/**
 *	Write attribute VerOffset related method
 *	Description: vertical BPM offset - default 0
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SimulatedE2BPM::write_VerOffset(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::write_VerOffset(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(SimulatedE2BPM::write_VerOffset) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	*attr_VerOffset_read = w_val;
	update_offset_scale();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::write_VerOffset
}
//--------------------------------------------------------
/**
 *	Read attribute VerPos related method
 *	Description: Vertical position [mm] readout , including offsets and scale factors
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SimulatedE2BPM::read_VerPos(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::read_VerPos(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::read_VerPos) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	try{
		Tango::DeviceAttribute da = orbit_dev->read_attribute("VerPos");
		da >> v_pos;
		*attr_rawVerPos_read = v_pos[index] ;
		*attr_VerPos_read = (*attr_rawVerPos_read * *attr_ScaleFactor_read) +  *attr_VerOffset_read;
	}
	catch (Tango::DevFailed& e)
	{
		*attr_rawVerPos_read = NAN;
		*attr_VerPos_read = (*attr_rawVerPos_read * *attr_ScaleFactor_read) +  *attr_VerOffset_read;
		set_status("error reading VerPos");
		ERROR_STREAM << "error reading ClosedOrbit_v from : " << orbitDevName.c_str() << " " << index << std::endl;
		Tango::Except::re_throw_exception(e,(const char*) "Failed to read VerPos", (const char*) "DevFailed from device", (const char*) "SimulatedBeamOrbit::read_VerPos");
	}
	attr.set_value(attr_VerPos_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::read_VerPos
}
//--------------------------------------------------------
/**
 *	Read attribute rawHorPos related method
 *	Description: Raw horizontal position read from simulator
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SimulatedE2BPM::read_rawHorPos(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::read_rawHorPos(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::read_rawHorPos) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value

	attr.set_value(attr_rawHorPos_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::read_rawHorPos
}
//--------------------------------------------------------
/**
 *	Read attribute rawVerPos related method
 *	Description: Raw  vertical position read from simulator
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SimulatedE2BPM::read_rawVerPos(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::read_rawVerPos(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::read_rawVerPos) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value

	attr.set_value(attr_rawVerPos_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::read_rawVerPos
}
//--------------------------------------------------------
/**
 *	Write attribute injectCurr related method
 *	Description: attribute to injtect from the machine model the beam current
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SimulatedE2BPM::write_injectCurr(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::write_injectCurr(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(SimulatedE2BPM::write_injectCurr) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	injected_curr = w_val;
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::write_injectCurr
}
//--------------------------------------------------------
/**
 *	Read attribute ScaleFactor related method
 *	Description: write the scaling factor used to covert injected (raw )Position  to read-out Positions
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SimulatedE2BPM::read_ScaleFactor(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::read_ScaleFactor(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::read_ScaleFactor) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr.set_value(attr_ScaleFactor_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::read_ScaleFactor
}
//--------------------------------------------------------
/**
 *	Write attribute ScaleFactor related method
 *	Description: write the scaling factor used to covert injected (raw )Position  to read-out Positions
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void SimulatedE2BPM::write_ScaleFactor(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::write_ScaleFactor(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(SimulatedE2BPM::write_ScaleFactor) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	*attr_ScaleFactor_read = w_val;
	update_offset_scale();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::write_ScaleFactor
}
//--------------------------------------------------------
/**
 *	Read attribute HorPosHistory related method
 *	Description: Turn by turn horizontal position, including offsets and scale factors
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 10000
 */
//--------------------------------------------------------
void SimulatedE2BPM::read_HorPosHistory(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::read_HorPosHistory(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::read_HorPosHistory) ENABLED START -----*/
	/* clang-format on */
	try{
		Tango::DeviceAttribute da = orbit_dev->read_attribute("HorPosTbT");
		std::vector<Tango::DevDouble> pos_tbt;
		da >> pos_tbt;
		if (da.dim_x != n_turns){
			n_turns = da.dim_x;  //n turns
			n_turns_new_value();
		}

		n_bpms = da.dim_y;  //N BPMS

		int start =  index * n_turns;
		//auto end =   start + n_turns - 1;
		int end = (index * n_turns) + n_turns -1;

		for(int i=0,j=start; i < n_turns; i++,j++){
			raw_h_pos_tbt[i]=pos_tbt[j];
			h_pos_tbt[i]=(raw_h_pos_tbt[i] * *attr_ScaleFactor_read) + *attr_HorOffset_read;
		}


		//attr_HorPos_read = (*attr_rawHorPos_read * *attr_ScaleFactor_read) +  *attr_HorOffset_read;
	}
	catch (Tango::DevFailed& e)
	{
		//*attr_rawHorPos_read = NAN;
		//*attr_HorPos_read = (*attr_rawHorPos_read * *attr_ScaleFactor_read) +  *attr_HorOffset_read;
		set_status("error reading HorPosTbT");
		ERROR_STREAM << "error reading HorPosTbT from : " << orbitDevName.c_str()<< std::endl;
		Tango::Except::re_throw_exception(e,(const char*) "Failed to read HorPosTbT", (const char*) "DevFailed from device", (const char*) "SimulatedBeamOrbit::read_HorPos");
	}
	//	Set the attribute value
	attr.set_value(attr_HorPosHistory_read,  n_turns);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::read_HorPosHistory
}
//--------------------------------------------------------
/**
 *	Read attribute VerPosHistory related method
 *	Description: Turn by turn vertical  position, including offsets and scale factors
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 10000
 */
//--------------------------------------------------------
void SimulatedE2BPM::read_VerPosHistory(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::read_VerPosHistory(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::read_VerPosHistory) ENABLED START -----*/
	/* clang-format on */
	try{
		Tango::DeviceAttribute da = orbit_dev->read_attribute("VerPosTbT");
		std::vector<Tango::DevDouble> pos_tbt;
		da >> pos_tbt;
		if (da.dim_x != n_turns){
			n_turns = da.dim_x;  //n turns
			n_turns_new_value();
		}

		n_bpms = da.dim_y;  //N BPMS

		int start =  index * n_turns;
		//auto end =   start + n_turns - 1;
		int end = (index * n_turns) + n_turns -1;

		for(int i=0,j=start; i < n_turns; i++,j++){
			raw_v_pos_tbt[i]=pos_tbt[j];
			v_pos_tbt[i]=(raw_v_pos_tbt[i] * *attr_ScaleFactor_read) + *attr_VerOffset_read;
		}
	}
	catch (Tango::DevFailed& e)
	{
		//*attr_rawHorPos_read = NAN;
		//*attr_HorPos_read = (*attr_rawHorPos_read * *attr_ScaleFactor_read) +  *attr_HorOffset_read;
		set_status("error reading VerPosTbT");
		ERROR_STREAM << "error reading VerPosTbT from : " << orbitDevName.c_str()<< std::endl;
		Tango::Except::re_throw_exception(e,(const char*) "Failed to read VerPosTbT", (const char*) "DevFailed from device", (const char*) "SimulatedBeamOrbit::read_HorPos");
	}
	//	Set the attribute value
	attr.set_value(attr_VerPosHistory_read,  n_turns);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::read_VerPosHistory
}
//--------------------------------------------------------
/**
 *	Read attribute SumHistory related method
 *	Description: Turn by turn sum signal
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 10000
 */
//--------------------------------------------------------
void SimulatedE2BPM::read_SumHistory(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::read_SumHistory(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::read_SumHistory) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr.set_value(attr_SumHistory_read, SumHistoryAttrib::X_DATA_SIZE);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::read_SumHistory
}
//--------------------------------------------------------
/**
 *	Read attribute rawHorPosHistory related method
 *	Description: Raw turn by turn horizontal position as read form simulator
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 10000
 */
//--------------------------------------------------------
void SimulatedE2BPM::read_rawHorPosHistory(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::read_rawHorPosHistory(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::read_rawHorPosHistory) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr.set_value(attr_rawHorPosHistory_read, n_turns);
	///* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::read_rawHorPosHistory
}
//--------------------------------------------------------
/**
 *	Read attribute rawVerPosHistory related method
 *	Description: Raw turn by turn vertical position as read form simulator
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 10000
 */
//--------------------------------------------------------
void SimulatedE2BPM::read_rawVerPosHistory(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SimulatedE2BPM::read_rawVerPosHistory(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::read_rawVerPosHistory) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr.set_value(attr_rawVerPosHistory_read, n_turns);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::read_rawVerPosHistory
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::add_dynamic_attributes()
 *	Description: Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void SimulatedE2BPM::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(SimulatedE2BPM::add_dynamic_attributes) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code to create and add dynamic attributes if any
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command Reset related method
 *	Description: Reset to normal condition - recover form disabled state
 *
 */
//--------------------------------------------------------
void SimulatedE2BPM::reset()
{
	DEBUG_STREAM << "SimulatedE2BPM::Reset()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::reset) ENABLED START -----*/
	/* clang-format on */

	//	Add your own code

	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::reset
}
//--------------------------------------------------------
/**
 *	Command GetBPMName related method
 *	Description: Get official BPM name
 *
 *	@returns
 */
//--------------------------------------------------------
Tango::DevString SimulatedE2BPM::get_bpmname()
{
	Tango::DevString argout;
	DEBUG_STREAM << "SimulatedE2BPM::GetBPMName()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::get_bpmname) ENABLED START -----*/
	/* clang-format on */

	//	Add your own code
	argout  = CORBA::string_dup(name.c_str());

	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::get_bpmname
	return argout;
}
//--------------------------------------------------------
/**
 *	Command GetBPMIndex related method
 *	Description: Get index of BPM in global orbit
 *
 *	@returns
 */
//--------------------------------------------------------
Tango::DevULong SimulatedE2BPM::get_bpmindex()
{
	Tango::DevULong argout;
	DEBUG_STREAM << "SimulatedE2BPM::GetBPMIndex()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::get_bpmindex) ENABLED START -----*/
	/* clang-format on */

	//	Add your own code
    argout = index;
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::get_bpmindex
	return argout;
}
//--------------------------------------------------------
/**
 *	Command Fault related method
 *	Description: Force BPM to Fault state - simulate error
 *
 */
//--------------------------------------------------------
void SimulatedE2BPM::fault()
{
	DEBUG_STREAM << "SimulatedE2BPM::Fault()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::fault) ENABLED START -----*/
	/* clang-format on */

	//	Add your own code

	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::fault
}
//--------------------------------------------------------
/**
 *	Command On related method
 *	Description: Force BPM to ON  state and recover from simulated error
 *
 */
//--------------------------------------------------------
void SimulatedE2BPM::on()
{
	DEBUG_STREAM << "SimulatedE2BPM::On()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(SimulatedE2BPM::on) ENABLED START -----*/
	/* clang-format on */

	//	Add your own code

	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::on
}
//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::add_dynamic_commands()
 *	Description: Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void SimulatedE2BPM::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(SimulatedE2BPM::add_dynamic_commands) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code to create and add dynamic commands if any
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::add_dynamic_commands
}

/*----- PROTECTED REGION ID(SimulatedE2BPM::namespace_ending) ENABLED START -----*/
/* clang-format on */
//	Additional Methods
void SimulatedE2BPM::update_offset_scale()
{
	*attr_HorPos_read = (*attr_rawHorPos_read * *attr_ScaleFactor_read) +  *attr_HorOffset_read;
	*attr_VerPos_read = (*attr_rawVerPos_read * *attr_ScaleFactor_read) +  *attr_VerOffset_read;
	for(int i=0; i < n_turns; i++){
		h_pos_tbt[i]=(raw_h_pos_tbt[i] * *attr_ScaleFactor_read) + *attr_HorOffset_read;
		//v_pos_tbt[i]=(raw_v_pos_tbt[i] * *attr_ScaleFactor_read) + *attr_VerOffset_read;
	}
}

void SimulatedE2BPM::n_turns_new_value()
{
	raw_v_pos_tbt.resize(n_turns);
	v_pos_tbt.resize(n_turns);
	raw_h_pos_tbt.resize(n_turns);
	h_pos_tbt.resize(n_turns);
	attr_rawVerPosHistory_read = raw_v_pos_tbt.data();
	attr_VerPosHistory_read = v_pos_tbt.data();
	attr_rawHorPosHistory_read = raw_h_pos_tbt.data();
	attr_HorPosHistory_read = h_pos_tbt.data();
	*attr_BufSize_read=n_turns;
}
/* clang-format off */// //--------------------------------------------------------
// /**
//  *	Read attribute HorPosHistory related method
//  *	Description: Turn by turn horizontal postion
//  *
//  *	Data type:	Tango::DevDouble
//  *	Attr type:	Spectrum max = 10000
//  */
// //--------------------------------------------------------
// void SimulatedE2BPM::read_HorPosHistory(Tango::Attribute &attr)
// {
// 	DEBUG_STREAM << "SimulatedE2BPM::read_HorPosHistory(Tango::Attribute &attr) entering... " << std::endl;
// 	/* clang-format on */
// 	//	Set the attribute value
// 	attr.set_value(attr_HorPosHistory_read, HorPosHistoryAttrib::X_DATA_SIZE);
// 	/* clang-format off */
// }


/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::namespace_ending
} //	namespace
