/*----- PROTECTED REGION ID(SimulatedE2BPMStateMachine.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        SimulatedE2BPMStateMachine.cpp
//
// description : State machine file for the SimulatedE2BPM class
//
// project :     SimulatedE2BPM
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include "SimulatedE2BPM.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::SimulatedE2BPMStateMachine.cpp

//================================================================
//  States  |  Description
//================================================================


namespace SimulatedE2BPM_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_HorOffset_allowed()
 *	Description: Execution allowed for HorOffset attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_HorOffset_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for HorOffset attribute in Write access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::HorOffsetStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::HorOffsetStateAllowed_WRITE

	//	Not any excluded states for HorOffset attribute in read access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::HorOffsetStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::HorOffsetStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_HorPos_allowed()
 *	Description: Execution allowed for HorPos attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_HorPos_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for HorPos attribute in read access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::HorPosStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::HorPosStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_Sum_allowed()
 *	Description: Execution allowed for Sum attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_Sum_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Sum attribute in read access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::SumStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::SumStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_BufSize_allowed()
 *	Description: Execution allowed for BufSize attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_BufSize_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for BufSize attribute in Write access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::BufSizeStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::BufSizeStateAllowed_WRITE

	//	Not any excluded states for BufSize attribute in read access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::BufSizeStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::BufSizeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_tbtEnable_allowed()
 *	Description: Execution allowed for tbtEnable attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_tbtEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for tbtEnable attribute in Write access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::tbtEnableStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::tbtEnableStateAllowed_WRITE

	//	Not any excluded states for tbtEnable attribute in read access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::tbtEnableStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::tbtEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_VerOffset_allowed()
 *	Description: Execution allowed for VerOffset attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_VerOffset_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for VerOffset attribute in Write access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::VerOffsetStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::VerOffsetStateAllowed_WRITE

	//	Not any excluded states for VerOffset attribute in read access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::VerOffsetStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::VerOffsetStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_VerPos_allowed()
 *	Description: Execution allowed for VerPos attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_VerPos_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for VerPos attribute in read access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::VerPosStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::VerPosStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_rawHorPos_allowed()
 *	Description: Execution allowed for rawHorPos attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_rawHorPos_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for rawHorPos attribute in read access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::rawHorPosStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::rawHorPosStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_rawVerPos_allowed()
 *	Description: Execution allowed for rawVerPos attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_rawVerPos_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for rawVerPos attribute in read access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::rawVerPosStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::rawVerPosStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_injectCurr_allowed()
 *	Description: Execution allowed for injectCurr attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_injectCurr_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for injectCurr attribute in Write access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::injectCurrStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::injectCurrStateAllowed_WRITE

	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_ScaleFactor_allowed()
 *	Description: Execution allowed for ScaleFactor attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_ScaleFactor_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ScaleFactor attribute in Write access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::ScaleFactorStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::ScaleFactorStateAllowed_WRITE

	//	Not any excluded states for ScaleFactor attribute in read access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::ScaleFactorStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::ScaleFactorStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_HorPosHistory_allowed()
 *	Description: Execution allowed for HorPosHistory attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_HorPosHistory_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for HorPosHistory attribute in read access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::HorPosHistoryStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::HorPosHistoryStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_VerPosHistory_allowed()
 *	Description: Execution allowed for VerPosHistory attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_VerPosHistory_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for VerPosHistory attribute in read access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::VerPosHistoryStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::VerPosHistoryStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_SumHistory_allowed()
 *	Description: Execution allowed for SumHistory attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_SumHistory_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for SumHistory attribute in read access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::SumHistoryStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::SumHistoryStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_rawHorPosHistory_allowed()
 *	Description: Execution allowed for rawHorPosHistory attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_rawHorPosHistory_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for rawHorPosHistory attribute in read access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::rawHorPosHistoryStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::rawHorPosHistoryStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_rawVerPosHistory_allowed()
 *	Description: Execution allowed for rawVerPosHistory attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_rawVerPosHistory_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for rawVerPosHistory attribute in read access.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::rawVerPosHistoryStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::rawVerPosHistoryStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_Reset_allowed()
 *	Description: Execution allowed for Reset attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_Reset_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Reset command.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::ResetStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::ResetStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_GetBPMName_allowed()
 *	Description: Execution allowed for GetBPMName attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_GetBPMName_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetBPMName command.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::GetBPMNameStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::GetBPMNameStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_GetBPMIndex_allowed()
 *	Description: Execution allowed for GetBPMIndex attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_GetBPMIndex_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetBPMIndex command.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::GetBPMIndexStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::GetBPMIndexStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_Fault_allowed()
 *	Description: Execution allowed for Fault attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_Fault_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Fault command.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::FaultStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::FaultStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : SimulatedE2BPM::is_On_allowed()
 *	Description: Execution allowed for On attribute
 */
//--------------------------------------------------------
bool SimulatedE2BPM::is_On_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for On command.
	/*----- PROTECTED REGION ID(SimulatedE2BPM::OnStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::OnStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(SimulatedE2BPM::SimulatedE2BPMStateAllowed.AdditionalMethods) ENABLED START -----*/
/* clang-format on */
//	Additional Methods
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	SimulatedE2BPM::SimulatedE2BPMStateAllowed.AdditionalMethods

}	//	End of namespace
